<?php
	error_reporting (E_ALL|E_STRICT);
	
	require '../tmp/sql.php';
	require '../classes/mysql.php';
	require '../classes/settings.php';
	require '../classes/security.php';
	require '../classes/functions.php';
	require '../classes/session.php';
	require '../classes/login.php';
	require '../classes/template.php';
	require '../classes/player.php';
	require '../classes/stats.php';
	require '../classes/signatures.php';
	
	
	// Navigation
	echo '<a href="apitest.php?info">PHP-Info</a><br/>';
	echo '<a href="apitest.php?more">Settings</a><br/>';
	echo '<a href="apitest.php?curl">cURL Test</a><br/>';
	echo '<a href="apitest.php?localstats">Lokale Statsdaten</a><br/>';
	echo '<a href="apitest.php?apistats">API Statsdaten</a><br/>';
	echo '<a href="apitest.php?platoons">Platoons</a><br/>';
	echo '<a href="apitest.php?compare">Compare-Menu</a><br/>';
	echo '<a href="apitest.php?assignments">Assignment-Test</a><br/>';
	echo '<a href="apitest.php?signatures">Signaturen-Test</a><br/>';
	echo '<a href="apitest.php?history">History-DB komprimieren</a><br/>';
	echo '<br/><br/><br/>';
	
	
	// PHP-Info
	if (isset($_GET['info'])) {
		die(phpinfo());
	}
	
	
	// Settings
	if (isset($_GET['more'])) {
		$settings = new Settings();
		echo "<br/>Ident: ".$settings->get('ident');
		echo "<br/>Key: ".$settings->get('key');
		echo "<br/>Path: ".$settings->get('path');
		die();
	}
	
	
	// cURL-Test
	if (isset($_GET['curl'])) {
		$postdata = Array(
			'player' => 'ezzemm',
			'opt' => 'clear,global'
		);
		
		// BF3STATS-API
		$c=curl_init('http://api.bf3stats.com/pc/player/');
		curl_setopt($c,CURLOPT_HEADER,false); curl_setopt($c,CURLOPT_POST,true); curl_setopt($c,CURLOPT_USERAGENT,'BF3StatsAPI/0.1'); curl_setopt($c,CURLOPT_HTTPHEADER,array('Expect:')); curl_setopt($c,CURLOPT_RETURNTRANSFER,true); curl_setopt($c,CURLOPT_CONNECTTIMEOUT,5); curl_setopt($c,CURLOPT_POSTFIELDS,$postdata);
		
		$result = curl_exec($c);
		$status = curl_getinfo($c,CURLINFO_HTTP_CODE); $error = curl_error($c); $errno = curl_errno($c);
		curl_close($c);
		
		echo "<br><br>BF3STATS:<br>Status: $status<br>Error: $error ($errno)<br>Result: $result";
		
		
		// THIS PAGE
		$settings = new Settings();
		$c=curl_init($settings->get('path').'/admin/apitest.php');
		curl_setopt($c,CURLOPT_HEADER,false); curl_setopt($c,CURLOPT_POST,true); curl_setopt($c,CURLOPT_USERAGENT,'BF3StatsAPI/0.1'); curl_setopt($c,CURLOPT_HTTPHEADER,array('Expect:')); curl_setopt($c,CURLOPT_RETURNTRANSFER,true); curl_setopt($c,CURLOPT_CONNECTTIMEOUT,5); curl_setopt($c,CURLOPT_POSTFIELDS,$postdata);
		
		$result = curl_exec($c);
		$status = curl_getinfo($c,CURLINFO_HTTP_CODE); $error = curl_error($c); $errno = curl_errno($c);
		curl_close($c);
		
		echo "<br><br>THIS PAGE:<br>Status: $status<br>Error: $error ($errno)<br>Result: $result";
		
		
		// EZSTATS
		$c=curl_init('http://curl.ezstats.org/?version');
		curl_setopt($c,CURLOPT_HEADER,false); curl_setopt($c,CURLOPT_POST,true); curl_setopt($c,CURLOPT_USERAGENT,'BF3StatsAPI/0.1'); curl_setopt($c,CURLOPT_HTTPHEADER,array('Expect:')); curl_setopt($c,CURLOPT_RETURNTRANSFER,true); curl_setopt($c,CURLOPT_CONNECTTIMEOUT,5); curl_setopt($c,CURLOPT_POSTFIELDS,$postdata);
		
		$result = json_decode(curl_exec($c));
		$status = curl_getinfo($c,CURLINFO_HTTP_CODE); $error = curl_error($c); $errno = curl_errno($c);
		curl_close($c);
		
		echo "<br><br>EZSTATS:<br>Status: $status<br>Error: $error ($errno)<br>Result: $result";
		
		die();
	}
	
	
	// Abruf der lokalen Statsdaten
	if (isset($_GET['localstats'])) {
		echo "<pre>";
		$stats = new Stats(11);
		$ass = $stats->get('vehicles');
		
		echo "<table><tr><td style=\"vertical-align: top\"><pre>";
			//print_r($ass['XPACK4']);
		echo "</td><td style=\"vertical-align: top;\"><pre>";
			print_r($ass);
		echo "</td><td style=\"vertical-align: top\"><pre>";
			foreach ($stats->get('weapons') as $key => $value) {
				//echo $key.': '.$value->category;
				//echo $key;
				//echo "<br>";
			}
		echo "</td></tr></table>";
	}
	
	
	// Stats-Abfrage bei BF3Stats
	if (isset($_GET['apistats'])) {
		echo "<pre>";
		
		$postdata = Array(
			'player' => 'ezzemm',
			'opt' => 'clear,vehicles,vehiclesName,vehiclesInfo'//'all,urls,ranking'//'clear,ranking,equipment,equipmentRanking' //
		);
		
		$c=curl_init('http://api.bf3stats.com/pc/player/');
		curl_setopt($c,CURLOPT_HEADER,false);
		curl_setopt($c,CURLOPT_POST,true);
		curl_setopt($c,CURLOPT_USERAGENT,'BF3StatsAPI/0.1');
		curl_setopt($c,CURLOPT_HTTPHEADER,array('Expect:'));
		curl_setopt($c,CURLOPT_RETURNTRANSFER,true);
		curl_setopt($c,CURLOPT_POSTFIELDS,$postdata);
		$result = json_decode(curl_exec($c));
		$statuscode = curl_getinfo($c,CURLINFO_HTTP_CODE);
		curl_close($c);
		
		print_r($result);
	}
	
	
	// Abruf eines Objekts mit Platoon-Mitgliedern
	if (isset($_GET['platoons'])) {
		echo "<pre>";
		
		$c=curl_init('http://battlelog.battlefield.com/bf3/platoon/2832655241047020983/listmembers/');
		//$c=curl_init('http://battlelog.battlefield.com/bf3/platoon/1/listmembers/');
		curl_setopt($c,CURLOPT_HEADER,false);
		curl_setopt($c,CURLOPT_HTTPHEADER,array('X-AjaxNavigation: 1'));
		curl_setopt($c,CURLOPT_RETURNTRANSFER,true);
		$result = json_decode(curl_exec($c));
		curl_close($c);
		
		//$platoon_name = $result->context->platoon->name;
		//echo $platoon_name."<br/><br/><br/>";
		
		$result = $result->context->listMembers;
		print_r($result);
	}
	
	
	// Listen-Generierung fr Compare-Menu
	if (isset($_GET['compare'])) {
		echo "<pre>";
		
		$stats = new Stats(11);
		$weapons = $stats->get('weapons');
		$cats = Array();
		
		foreach ($weapons as $key => $weapon) {
			$cats[] = $weapon->category;
		}
		
		$cats = array_unique($cats);
		sort($cats);
		print_r($cats);
		echo "<br><br><br><br>";
		foreach ($weapons as $key => $weapon) {
			if ($weapon->category == "_US SG") 
				echo '&lt;li&gt;&lt;a href="compare.php?weapon='.$key.'">'.$weapon->name.'&lt;/a&gt;&lt;/li&gt;<br>';
		}
		echo '&lt;li&gt;&lt;/li&gt;<br>';
	}
	
	
	// Assignment-Test
	if (isset($_GET['assignments'])) {
		echo "<pre>";
		$stats = new Stats(11);
		$ass = $stats->get('assignments');
		$i = 0;
		
		foreach($ass['PREMIUM'] as $key => $obj) {
			echo $i.': '.$obj->name;
			echo "<br>";
			$i++;
		}
	}
	
	
	// Signaturen-Test
	if (isset($_GET['signatures'])) {
		echo "<pre>";
		
		$sig = new Signatures(11);
		echo $sig->create_signature();
	}
	
	
	// History-DB komprimieren
	if (isset($_GET['history'])) {
		$sql = new MySQL(); if ($sql->debug) error_reporting (E_ALL|E_STRICT); else error_reporting (0);
		$time = 20; // Anzahl Tage zwischen zwei Datenpunkten
		$time = $time * 24 * 60 * 60; // Anzahl Tage in Sekunden
		
		$sql->query('SELECT p.id FROM '.$sql->prefix.'player p WHERE p.id != 1');
		
		while ($players = $sql->fetchAssoc()) {
			$pid = $players['id'];
			$stamp = 0;
			
			$sq2 = new MySQL();
			$sq2->query('SELECT id, date FROM '.$sq2->prefix.'history_global_'.$pid);
			
			while ($row = $sq2->fetchAssoc()) {
				// Der aktuelle Eintrag ist wird behalten
				if ($stamp + $time <= $row['date']) {
					$stamp = $row['date'];
				}
				// Der aktuelle Eintrag ist wird gelscht
				else {
					$sq3 = new MySQL();
					$sq3->query('DELETE FROM '.$sq3->prefix.'history_global_'.$pid.' WHERE id = "'.$row['id'].'"');
					$sq3->query('DELETE FROM '.$sq3->prefix.'history_scores_'.$pid.' WHERE id = "'.$row['id'].'"');
				}
			}
			
			echo "Daten des Spielers ".$pid." wurden komprimiert<br/>";
		}
	}
?>