<?php
	class Player {
		private $sql = NULL;
		private $tpl = NULL;
		private $func = NULL;
		private $settings = NULL;
		private $stats = NULL;
		private $tables = NULL;
		
		public function __construct() {
			$this->sql  = new MySQL();
			$this->func = new Functions();
			$this->settings = new Settings();
			$this->stats = new Stats();
			$this->tables = $this->stats->tables;
			$this->tpl  = new Templates();
			$this->tpl->load_phrases("admin", true);
		}
		
		
		public function add($name, $platform) {
			// Test ob Name bergeben wurde 
			if (trim($name) == "") {
				return $this->tpl->phrase("message_no_player_given");
			}
			
			// Name wurde bergeben
			else {
				// berprfen ob der Name in der Datenbank vorhanden ist
				$this->sql->query('SELECT id FROM '.$this->sql->prefix.'player WHERE name = "'.$name.'" AND platform = "'.$platform.'"');
				
				if($this->sql->count()) {
					// Name ist schon in der DB vorhanden / Message generieren / Spielername in die Phrase laden 
					$message = $this->tpl->phrase("message_player_already_added");
					eval ( "\$message = \"$message\";" );
					return $message;
				} 
				else {
					// Name ist noch nicht in der DB vorhanden / Spieler in die DB speichern
					$this->sql->query('INSERT INTO '.$this->sql->prefix.'player (name, platform) VALUES ("'.$name.'", "'.$platform.'")');
					$playerid = $this->sql->id;
					
					foreach ($this->tables as $table) {
						$this->sql->query('INSERT INTO '.$this->sql->prefix.'stats_'.$table.' (id) VALUES ("'.$playerid.'")');
					}
					
					
					// History-Tabellen erstellen
					if (!function_exists("get_query")) {
						function get_query($file, $array) { return str_replace(Array("#PREFIX#", "#PLAYERID#"), $array, file_get_contents("queries/history_".$file.".sql")); }
					}
					
					$this->sql->query(get_query("global", Array($this->sql->prefix, $playerid)));
					$this->sql->query(get_query("scores", Array($this->sql->prefix, $playerid)));
					
					
					// Spieler updaten mit der Spieler-ID
					$result = $this->update($playerid, $name, $platform);
					
					
					// Daten der Aktualisierung in die Spielereigenschaften schreiben
					$this->sql->query('
						UPDATE `'.$this->sql->prefix.'player` SET
							`last_update` = "'.time().'",
							`checkstate`  = "'.$result['checkstate'].'",
							`pushed`      = "'.$result['push'].'"
						WHERE `id` = "'.$playerid.'"
					');
					
					
					// Message generieren / Spielername in die Phrase laden
					$message = $this->tpl->phrase("message_add_player");
					eval ( "\$message = \"$message\";" );
					return $message;
				}
			}
		}
		
		
		public function delete($playerid = NULL, $name = "NoName") {
			if ($playerid === NULL) {
				return "ERROR: No Player-ID given";
			} else {
				$this->sql->query('DELETE FROM '.$this->sql->prefix.'player WHERE id = "'.$playerid.'"');
				
				foreach ($this->tables as $table) {
					$this->sql->query('DELETE FROM '.$this->sql->prefix.'stats_'.$table.' WHERE id = "'.$playerid.'"');
				}
				
				$this->sql->query('DROP TABLE '.$this->sql->prefix.'history_global_'.$playerid);
				$this->sql->query('DROP TABLE '.$this->sql->prefix.'history_scores_'.$playerid);
				
				$message = $this->tpl->phrase("message_delete_player");
				eval ( "\$message = \"$message\";" );
				return $message;
			}
		}
		
		
		public function update($playerid, $name, $platform) {
			### STATS-DATEN ABRUFEN ###
			$postdata = Array(
				'player' => $name,
				'opt' => 'all,urls,lastseen,assignments,ranking,weaponsRanking,equipmentRanking,vehiclesRanking'
			);
			
			$c=curl_init('http://api.bf3stats.com/'.$platform.'/player/');
			curl_setopt($c,CURLOPT_HEADER,false);
			curl_setopt($c,CURLOPT_POST,true);
			curl_setopt($c,CURLOPT_USERAGENT,'BF3StatsAPI/0.1');
			curl_setopt($c,CURLOPT_HTTPHEADER,array('Expect:'));
			curl_setopt($c,CURLOPT_RETURNTRANSFER,true);
			curl_setopt($c,CURLOPT_POSTFIELDS,$postdata);
			$result = json_decode(curl_exec($c));
			$statuscode = curl_getinfo($c,CURLINFO_HTTP_CODE);
			curl_close($c);
			
			
			if( $statuscode == 200 AND $result->status == "data") {
				### MANUELLE DB-QUERIES ###
				$date_lastseen = isset($result->date_lastseen) ? $result->date_lastseen : "0";
				$srv = isset($result->srv) ? $this->convert($result->srv) : "0";
				
				$this->sql->query('
					UPDATE `'.$this->sql->prefix.'player` SET
						`country`      = "'.$result->country.'",
						`country_name` = "'.$result->country_name.'",
						`country_img`  = "'.$result->country_img.'",
						`url`          = "'.$result->url.'",
						`battlelog`    = "'.$result->battlelog.'",
						`date_check`   = "'.$result->stats->date_check.'",
						`date_update`  = "'.$result->stats->date_update.'",
						`rank`         = "'.$this->convert($result->stats->rank).'",
						`nextranks`    = "'.$this->convert($result->stats->nextranks).'",
						`date_lastseen`= "'.$date_lastseen.'",
						`srv`          = "'.$srv.'"
					WHERE `id` = "'.$playerid.'"
				');
				
				
				### AUTOMATISIERTE DB-QUERIES ###
				// Stats-Tabellen die automatisch aktualisiert werden
				foreach ($this->tables as $table) {
					// Spalten einer Tabelle die aktualisiert werden
					$columns = $this->func->show_columns_of_table('stats_'.$table);
					
					// Aktualisieren der Zellen
					
					if (is_object($result) AND is_object($result->stats) AND isset($result->stats->$table) AND is_object($result->stats->$table)) {
						foreach ($columns as $column) {
							//var_dump(is_object($result->stats->$table));
							$this->sql->query('
								UPDATE `'.$this->sql->prefix.'stats_'.$table.'`
								SET `'.$column.'` = "'.$this->convert($result->stats->$table->$column).'"
								WHERE `id` = '.$playerid.'
							');
						}
					}
				}
				
				
				### HISTORY-DB-QUERIES ###
				// Anpassungen fr den Armored-Kill-DLC
				$this->sql->query('DESCRIBE `'.$this->sql->prefix.'history_scores_'.$playerid.'` `vehicleart`');
				if (!$this->sql->count()) $this->sql->query('
					ALTER TABLE `'.$this->sql->prefix.'history_scores_'.$playerid.'`
						ADD `vehicleart` int(99) NOT NULL DEFAULT 0 AFTER `vehiclesh`,
						ADD `vehiclelbt` int(99) NOT NULL DEFAULT 0 AFTER `vehiclesh`;
				');
				
				// Stats in die History-DB des Spielers eintragen
				foreach (Array("global", "scores") as $table) {
					// Standard-Variablen
					$tablename = 'history_'.$table.'_'.$playerid;              // Tabellenname
					$columns = $this->func->show_columns_of_table($tablename); // Spalten einer Tabelle die aktualisiert werden
					
					// Einfgen des Timestamps
					$this->sql->query('INSERT INTO `'.$this->sql->prefix.$tablename.'` (`date`) VALUES ('.time().')');
					$rowid = $this->sql->id;
					
					// Aktualisieren der Zellen
					foreach ($columns as $column) {
						if ($column != "date") {
							$this->sql->query('
								UPDATE `'.$this->sql->prefix.$tablename.'`
								SET `'.$column.'` = "'.$this->convert($result->stats->$table->$column).'"
								WHERE `id` = '.$rowid.'
							');
						}
					}
				}
				
				
				### AUSGABE DES ERGEBNISARRAYS ###
				$result = Array(
					'checkstate'  => $result->stats->checkstate,
					'update_left' => NULL,
					'push'        => "0"
				);
				return $result;
			} 
			
			else {
				$status = is_object($result) AND isset($result->status) ? $result->status : "-";
				$result = Array(
					'checkstate'  => $status,
					'update_left' => NULL,
					'push'        => "0"
				);
				return $result;
			}
		}
		
		
		public function push_sync($name, $platform, $type) {
			$data = Array(
				'ident'  => $this->settings->get('ident'),
				'time'   => time(),
				'type'   => $type,
				'player' => $name
			);
			
			$syncdata = $this->getAPIDataSigned('playerupdate', $platform, $data);
			
			if ($syncdata['status'] == 'error') {
				$syncdata['status'] = $syncdata['error'];
				$syncdata['update_left'] = '0';
			}
			
			$result = Array(
				'checkstate'  => $syncdata['status'],
				'update_left' => $syncdata['update_left'],
				'push'        => "1"
			);
			return $result;
		}
		
		
		
		// Fhrt einen signierten Request aus
		private function getAPIDataSigned($type, $platform, $data) {
			// Convert data to JSON
			$urlbase64 = array('+'=>'-','/'=>'_','='=>'');
			$data = strtr(base64_encode(json_encode($data)),$urlbase64);
			
			$postdata = Array(
				'data' => $data,
				'sig'  => strtr(base64_encode(hash_hmac('sha256', $data, $this->settings->get('key'), true)),$urlbase64)
			);
			
			// Run POST Request via CURL
			$c=curl_init('http://api.bf3stats.com/'.$platform.'/'.$type.'/');
			curl_setopt($c,CURLOPT_HEADER,false);
			curl_setopt($c,CURLOPT_POST,true);
			curl_setopt($c,CURLOPT_USERAGENT,'BF3StatsAPI/0.1');
			curl_setopt($c,CURLOPT_HTTPHEADER,array('Expect:'));
			curl_setopt($c,CURLOPT_RETURNTRANSFER,true);
			curl_setopt($c,CURLOPT_POSTFIELDS,$postdata);
			$data=curl_exec($c);
			$statuscode=curl_getinfo($c,CURLINFO_HTTP_CODE);
			curl_close($c);
			
			if($statuscode==200) {
				// Decode JSON Data
				$data=json_decode($data,true);
				return $data;

			} else {
				echo "BF3 Stats API error status: ".$statuscode;
				return false;
			}
		}
		
		
		private function convert($obj) {
			// Funktion: Objekt in JSON-String konvertieren und Slashes maskieren
			$string = json_encode($obj);
			if (get_magic_quotes_gpc()) $string = stripslashes($string);
			
			if(function_exists("mysqli_real_escape_string")) {
				$string = $this->sql->connection->real_escape_string($string);
			}
			else if(function_exists("mysql_real_escape_string")) {
				$string = mysql_real_escape_string($string);
			}
			else {
				$string = addslashes($string);
			}
			
			return $string;
		}
	}
?>